﻿Type=Class
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@

Sub Class_Globals
	Type Particle(X As Float, Y As Float, Xv As Float, Yv As Float, life As Short, Dead As Boolean, cl As Float, rw As Float)
	Type FireWork(X As Float, Y As Float, Height As Short, Color As Int, Exploded As Boolean, P As List)
	Type Trail(X As Float, Y As Float, pt As Int)
	Public gv As GameView
	Private FW() As FireWork
	Private RocketSpeed As Short
	Private Timer As Timer
	Private ivFireW As BitmapData
	Private Rocket() As BitmapData
	Private nFires As Short
	Private soundCk, stopped As Boolean
	Private fIdx As Short = -1
	Private imgSparks As Bitmap
End Sub

Public Sub Initialize(vGV As GameView,  nFr As Short)
	gv = vGV
	nFires = nFr
	Dim FW(nFires) As FireWork
	Dim Rocket(nFires) As BitmapData
    RocketSpeed = 10
	imgSparks.Initialize(File.DirAssets, "Sparks.png")
    Timer.Initialize("Timer", 16)
	ivFireW.Bitmap.InitializeMutable(100%x, 60%y)
	ivFireW.SrcRect.Initialize(0, 0, ivFireW.Bitmap.Width, ivFireW.Bitmap.Height)
	ivFireW.DestRect.Initialize(0, 0, ivFireW.Bitmap.Width, ivFireW.Bitmap.Height)
	gv.BitmapsData.Add(ivFireW)
	stopped = False
	For i = 0 To nFires - 1
		FW(i).Initialize
		FW(i).Y = -1
		Rocket(i).Bitmap.InitializeMutable(1, 32)
		Rocket(i).SrcRect.Initialize(0, 0, 1, 32)
		Rocket(i).DestRect.Initialize(10, 0, 11, 32)
	Next
	createRocket
	StartFireWork
	CallSubDelayed(Me, "starTimer")
End Sub

Private Sub starTimer
	Timer.Enabled = True
End Sub

Private Sub StartFireWork
	If stopped Then
    	For i = 0 To nFires - 1
			If FW(i).Y <> -1 Then Exit
		Next
		If i = nFires Then
			Timer.Enabled = False
			gv.RemoveView
			
		End If
		Return
	End If
    For i = 0 To nFires - 1
        If FW(i).Y = -1 Then
    		FW(i).X = Rnd(gv.Width *.1 , gv.Width *.9)
        	FW(i).Y = gv.Height
			FW(i).Height = Rnd(10%y, 40%y)
        	FW(i).Color = Colors.RGB(Rnd(0, 256), Rnd(0, 256), Rnd(0, 256))
        	FW(i).Exploded = False
			FW(i).P.Initialize
			Rocket(i).DestRect.Top = gv.Height
			Rocket(i).DestRect.Bottom = FW(i).Y + 32
			Rocket(i).DestRect.Left = FW(i).X
			Rocket(i).DestRect.Right = FW(i).X + 1
			gv.Invalidate2(Rocket(i).DestRect)
 			Utils.SoundPlay(3)
       End If
	Next
End Sub

Private Sub DrawFireWork(idx As Short)
    Dim DeadCount As Short
    Dim RndSpeed As Float
    Dim RndDeg As Float
	If FW(idx).Exploded Then
	Dim cvs As Canvas
	
'	#If WithAntiAliasing
'		Utils.SetAntiAlias(cvs, Utils.FILTER_BITMAP_FLAG)
'	#End If
	
		cvs.Initialize2(ivFireW.Bitmap)
		Dim szP As Int  = FW(idx).P.Size
		For i = 0 To szP - 1
			Dim RtSrc, RtDest As Rect
			Dim nFW As Particle = FW(idx).P.Get(i)
			If nFW.Life > 0 Then
				nFW.Life = nFW.Life - 1
				nFW.X = nFW.X + nFW.Xv
				nFW.Y = nFW.Y + nFW.Yv
				nFW.Xv = nFW.Xv / 1.05
				nFW.Yv = nFW.Yv / 1.05 + 0.05
				RtSrc.Initialize(nFW.cl, nFW.rw, nFW.cl + 15, nFW.rw + 15)
				RtDest.Initialize(nFW.X, nFW.Y, nFW.x + 11, nFW.Y + 11)
				cvs.DrawBitmap(imgSparks, RtSrc, RtDest)
			Else If nFW.Life > -20 Then
				nFW.Life = nFW.Life - 1
				nFW.X = nFW.X + nFW.Xv + (0.5 - Rnd(0, 100)/100)
				nFW.Y = nFW.Y + nFW.Yv + 0.1
				nFW.Xv = nFW.Xv / 1.05
				nFW.Yv = nFW.Yv
				RtSrc.Initialize(nFW.cl, nFW.rw, nFW.cl + 15, nFW.rw + 15)
				RtDest.Initialize(nFW.X, nFW.Y, nFW.x + 11, nFW.Y + 11)
				cvs.DrawBitmap(imgSparks, RtSrc, RtDest)
			Else
				nFW.Dead = True
				DeadCount = DeadCount + 1
			End If
		Next
		If soundCk Then
			Utils.SoundPlay(4)
			soundCk = False
		End If	
		If DeadCount > FW(idx).P.Size -1 Then
			FW(idx).Y = -1
			StartFireWork
		End If
	Else
		FW(idx).Y = FW(idx).Y - RocketSpeed
		If FW(idx).Y < FW(idx).Height Then
			moveRoket(idx, FW(idx).X, gv.Height)
			Dim ExplosionShape As Short
			ExplosionShape = Rnd(0, 5)
			soundCk = True
			Select Case ExplosionShape
				Case 0 'Regular
					Dim tot As Short = Rnd(0, 50) + 50
					Dim p As Int =  Rnd(0, 400)
					Dim sTmp As Short = p Mod 20
					If sTmp = 0 Then sTmp = 20
					For i = 0 To tot-1
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = Rnd(0, 20) + 20
						RndSpeed = Rnd(0,  6)
						RndDeg = Rnd(0, 360) / 57.3
						nFW.Xv = RndSpeed * Cos(RndDeg)
						nFW.Yv = RndSpeed * Sin(RndDeg)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next
					FW(idx).Exploded = True
				Case 1 'Circle
					Dim p As Int =  Rnd(0, 400)
					Dim sTmp As Short = p Mod 20
					If sTmp = 0 Then sTmp = 20
					For i = 0 To 35
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = 40
						nFW.Xv = 3 * Cos(((360 / 35) * (i + 1)) / 57.3)
						nFW.Yv = 3 * Sin(((360 / 35) * (i + 1)) / 57.3)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next 
					FW(idx).Exploded = True
				Case 2 'Spiral
					RndDeg = Rnd(0, 360)
					Dim p As Int =  Rnd(0, 400)
					Dim sTmp As Short = p Mod 20
					If sTmp = 0 Then sTmp = 20
					For i = 0 To 49
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = 40
						nFW.Xv = (i * 0.1) * Cos(((360 / 25) * (i + 1) + RndDeg) / 57.3)
						nFW.Yv = (i * 0.1) * Sin(((360 / 25) * (i + 1) + RndDeg) / 57.3)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next 
					FW(idx).Exploded = True
				Case 3 'Regular Random
					Dim tot As Short = Rnd(0, 50) + 50
					For i = 0 To tot-1
						Dim p As Int =  Rnd(0, 400)
						Dim sTmp As Short = p Mod 20
						If sTmp = 0 Then sTmp = 20
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = Rnd(0, 20) + 20
						RndSpeed = Rnd(0,  6)
						RndDeg = Rnd(0, 360) / 57.3
						nFW.Xv = RndSpeed * Cos(RndDeg)
						nFW.Yv = RndSpeed * Sin(RndDeg)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next 
					FW(idx).Exploded = True
				Case 4
					For i = 0 To 5 
						Dim p As Int =  Rnd(0, 400)
						Dim sTmp As Short = p Mod 20
						If sTmp = 0 Then sTmp = 20
						Dim nFW As Particle
						nFW.X = FW(idx).X
						nFW.Y = FW(idx).Y
						nFW.Life = Rnd(0, 100) + 50
						RndSpeed = Rnd(0,  10)
						RndDeg = Rnd(0, 360) / 60
						nFW.Xv = RndSpeed * Cos(RndDeg)
						nFW.Yv = RndSpeed * Sin(RndDeg)
						nFW.cl = 15 * (sTmp-1)
						nFW.rw = ((p-sTmp)/20) * 15
						FW(idx).P.Add(nFW)
					Next
					FW(idx).Exploded = True
			End Select
			
		Else
			moveRoket(idx, FW(idx).X, FW(idx).Y)
		End If
	End If
End Sub

Private Sub moveRoket(ix As Short, l As Float, t As Float)
	Rocket(ix).DestRect.Top = t
	Rocket(ix).DestRect.Bottom = t + 32
	Rocket(ix).DestRect.Left = l 
	Rocket(ix).DestRect.Right = l + 1
End Sub

Private Sub createRocket
	For i = 0 To nFires - 1
		Dim cvs As Canvas
	
'		#If WithAntiAliasing
'			Utils.SetAntiAlias(cvs, Utils.FILTER_BITMAP_FLAG)
'		#End If
		
		cvs.Initialize2(Rocket(i).Bitmap)
		cvs.DrawRect(Rocket(i).SrcRect, Colors.Transparent, True, 0)
		For z = 0 To 4
			Dim alp As Int = 255 - z * 51
			cvs.DrawLine(0, z * 8, 0, z * 8 + 8 , Colors.ARGB(alp, 243, 167, 51),1)
		Next		
		cvs.DrawBitmap(Rocket(i).Bitmap, Rocket(i).SrcRect, Rocket(i).DestRect)
		gv.BitmapsData.Add(Rocket(i))
	Next
End Sub

Private Sub Timer_Tick
	For fIdx = 0  To nFires - 1
		DrawFireWork(fIdx) 
	Next
	Dim bmp As Bitmap = CreateBitmapWithAlpha(ivFireW.Bitmap, 240) 
	ivFireW.Bitmap = bmp
	gv.Invalidate
End Sub

Public Sub Stop
	Timer.Enabled = False
	gv.RemoveView

End Sub

Private Sub CreateBitmapWithAlpha(myOriginalBitmap As Bitmap, newAlpha As Int) As Bitmap
  Dim canvas1 As Canvas
  Dim myNewBitmap As Bitmap
  myNewBitmap.initializeMutable(myOriginalBitmap.Width,myOriginalBitmap.Height)
  canvas1.initialize2(myNewBitmap)
  Dim CanvJO As JavaObject = canvas1
  CanvJO = CanvJO.GetField("canvas")  
  Dim J As JavaObject
  J.initializeContext()
  J.Runmethod("alphatize",Array(CanvJO,myOriginalBitmap,newAlpha))
  Return(myNewBitmap)
End Sub

