﻿Type=Activity
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private imgNone As ImageView
	Private imgA(4) As ImageView
	Private imgK(7) As ImageView
	Private imgCards(52) As ImageView
	Private Cards(52) As CardParms
	Private lstColumns(13) As List
	Private lstSelected As List
	Private CPrm As CParms
	Private Bmp As Bitmap
	Private CardsTop, CardsTop1 As Int
	Private CardsStp As Float
	Private Count As Short
	Private Col_Clicked As Short
	Private ColIni, ColEnd, img_Num As Short
	Private BlockTop As Int
	Private TurnIdx As Short
	Private isInitialized As Boolean
	Private lbMsg As Label
	Private btExit As Button
	Private btUndo As Button
	Private btNew As Button
	Private lstUndo As List
	Private ivBack As ImageView
	Private timeClick As Long
	Private Fire As Fireworks
	Private gv As GameView
	Private FireIsActive As Boolean
	Private Clk(13) As Short
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("L1")
	Activity.Title = "Solitaire"
	Dim Wd As Int = dipX(240)
	Dim lft As Int = (100%x - Wd) /2
	Dim hg As Int = dipX(200)
	Dim tp As Int = (100%y - hg) / 2
	ivBack.Initialize("")
	ivBack.Gravity = Gravity.FILL
	ivBack.Bitmap = LoadBitmap(File.DirAssets, "bkg.png")
	Activity.AddView(ivBack, lft, tp, Wd, hg)	
	Dim PsY As Int = 100%Y - dipY(70)
	btExit.Initialize("btExit")
	Activity.Addview(btExit, dipX(10), PsY, dipX(50), dipX(50))
	Utils.ButtonSetStateListDrawable(btExit, "Exit.png", "ExitPr.png", "ExitDb.png")
	btUndo.Initialize("btUndo")
	Activity.Addview(btUndo, dipX(70), PsY, dipX(50), dipX(50))
	Utils.ButtonSetStateListDrawable(btUndo, "Undo.png", "UndoPr.png", "UndoDb.png")
	btNew.Initialize("btNew")
	Activity.Addview(btNew, dipX(130), PsY, dipX(50), dipX(50))
	Utils.ButtonSetStateListDrawable(btNew, "New.png", "NewPr.png", "NewDb.png")
	lbMsg.Initialize("")
	lbMsg.TextColor = Colors.Yellow
	lbMsg.TextSize = 14 * Main.FontScale
	lbMsg.Gravity = Gravity.CENTER
	Activity.AddView(lbMsg, 0, 100%Y - dipY(90), 100%x, dipY(35))
	Dim ftr As Float = (100%x - dipX(40)) / 7
	CPrm.WdtSrc = 71
	CPrm.HgtSrc = 96
	ftr = ftr / CPrm.WdtSrc
	CPrm.WdtDest = CPrm.WdtSrc * ftr
	CPrm.HgtDest = CPrm.HgtSrc * ftr
	Bmp.Initialize(File.DirAssets, "Cards01.png")
	CardsTop = dipY(10)
	CardsTop1 = dipY(20) + CPrm.HgtDest
	CardsStp = 0.3
	For i = 0 To lstColumns.Length - 1 
		lstColumns(i).Initialize
	Next
	For i = 0 To imgA.Length - 1
		imgA(i).Initialize("")
		Activity.AddView(imgA(i), dipX(5) + i * (CPrm.WdtDest + dipX(5)), CardsTop, CPrm.WdtDest, CPrm.HgtDest)
		imgA(i).Bitmap = DrawImage(58)
	Next
	For i = 0 To imgK.Length - 1
		imgK(i).Initialize("")
		Activity.AddView(imgK(i), dipX(5) + i * (CPrm.WdtDest + dipX(5)), CardsTop1, CPrm.WdtDest, CPrm.HgtDest)
		imgK(i).Bitmap = DrawImage(59)
	Next
	imgNone.Initialize("imgNone")
	Activity.AddView(imgNone, 6 * (CPrm.WdtDest + dipX(5)), CardsTop, CPrm.WdtDest, CPrm.HgtDest)
	imgNone.Bitmap = DrawImage(57)
	BlockTop = CardsTop1
	Dim tp As Int = imgNone.Top
	Dim lft As Int = imgNone.Left
	For i = 0 To imgCards.Length - 1
		Cards(i).Initialize
		Cards(i).Seq = i + 1
		imgCards(i).Initialize("imgCards")
		imgCards(i).Bitmap = DrawImage(55)
		imgCards(i).Gravity = Gravity.FILL
		imgCards(i).Tag = i
		Cards(i).imgN = i
		Cards(i).Col = 12
		lstColumns(12).Add(i)
		Activity.AddView(imgCards(i), lft + i * 0.15, tp - i * 0.15, CPrm.WdtDest, CPrm.HgtDest)
	Next
	timeClick = (DateTime.now)
	isInitialized = False
	lstUndo.Initialize
	lstSelected.Initialize
	InitRandom
End Sub

Private Sub InitRandom
	For i = 0 To 11
		Clk(i) = 0
		lstColumns(i).Clear
	Next
	lstUndo.Clear
    Dim Random As Short
	Dim shtTmp As Short
    For i = 0 To 51
    	Random = Rnd(i, 52)
       	shtTmp = Cards(i).Seq
       	Cards(i).Seq = Cards(Random).Seq
       	Cards(Random).Seq = shtTmp
		If Cards(i).Seq > 39 Then
			Cards(i).Naipe  = 4
		Else If Cards(i).Seq > 26 Then
			Cards(i).Naipe  = 3
		Else If Cards(i).Seq > 13 Then
			Cards(i).Naipe  = 2
		Else
			Cards(i).Naipe  = 1	
		End If
		Cards(i).Value = Cards(i).Seq Mod 13
		If Cards(i).Value = 0 Then Cards(i).Value = 13
		Cards(i).Turned = False
    Next
	Count = 51
	Col_Clicked = 0
	ColIni = 0
	ColEnd = 6
	img_Num = ColIni - 1
	CallSubDelayed(Me, "InitCards")
End Sub

private Sub InitCards
	img_Num = img_Num + 1
	If img_Num > ColEnd Then
		ColIni = ColIni + 1
		If ColIni > ColEnd Then
			Col_Clicked = 0
			CallSubDelayed(Me, "InitTurn")
			Return
		End If
		img_Num = ColIni 
		BlockTop = BlockTop + CPrm.HgtDest * CardsStp
	End If
	imgCards(Count).BringToFront
	dSpeed(Count, imgK(img_Num).Left, BlockTop)
	lstColumns(img_Num).Add(Count)
	Cards(Count).Col = img_Num
	lstColumns(12).RemoveAt(Count)
	Count = Count - 1
	InitCards
End Sub

Private Sub InitTurn
	If Col_Clicked = 7 Then 
		CkOk
		isInitialized = True
		Return
	End If
	Dim Sz As Short = lstColumns(Col_Clicked).Size
	TurnIdx = lstColumns(Col_Clicked).Get(Sz - 1)
	Col_Clicked = Col_Clicked + 1
	Cards(TurnIdx).Turned = True
	Dim Turn As clTurn
	Turn.Initialize(Me)
	Turn.Img_to_Turn(imgCards(TurnIdx), Cards(TurnIdx).Seq, False, "InitTurn")
End Sub

Private Sub btNew_Click
	If isInitialized Then
		Dim res As Int = Msgbox2("Are you sure you want to quit this game?", "", "Yes", "", "No", Null)
    	If res = DialogResponse.NEGATIVE Then Return 
	End If
	If FireIsActive Then
		Activity.Color = Colors.RGB(0, 100, 0)
		FireIsActive = False
		Fire.Stop
	End If
	For i = 0 To lstColumns.Length - 1 
		lstColumns(i).Clear
	Next
	BlockTop = CardsTop1
	Dim tp As Int = imgNone.Top
	Dim lft As Int = imgNone.Left
	For i = 0 To imgCards.Length - 1
		Cards(i).Seq = i + 1
		imgCards(i).Bitmap = DrawImage(55)
		imgCards(i).Tag = i
		imgCards(i).BringToFront
		Cards(i).imgN = i
		Cards(i).Col = 12
		lstColumns(12).Add(i)
		imgCards(i).Left = lft + i * 0.15
		imgCards(i).Top =  tp - i * 0.15
	Next
	InitRandom	
End Sub

Private Sub btExit_Click
	If isInitialized Then
		Dim res As Int = Msgbox2("Are you sure you want to quit this game?", "", "Yes", "", "No", Null)
    	If res = DialogResponse.NEGATIVE Then Return 
	End If
	If FireIsActive Then
		FireIsActive = False
		Fire.Stop
	End If
	Activity.Finish
End Sub

Private Sub btUndo_Click
	If isInitialized = False Then Return
	Dim szU As Short = lstUndo.Size - 1
	If szU = -1 Then
		ToastMessageShow("No movement", False)
		Return
	End If
	Dim tUndo As Undo = lstUndo.Get(szU)
	Col_Clicked = tUndo.T_Col
	If Col_Clicked = -99 Then
		Col_Clicked = tUndo.F_Col
		Dim Last As Short = lstColumns(Col_Clicked).Size - 1
		If Last < 0  Then Return
		TurnIdx = lstColumns(Col_Clicked).Get(Last)
		imgCards(TurnIdx).BringToFront
		Cards(TurnIdx).Turned = False
		lstUndo.RemoveAt(szU)
		Dim Turn As clTurn
		Turn.Initialize(Me)
		Turn.Img_to_Turn(imgCards(TurnIdx), Cards(TurnIdx).Seq, True, "btUndo_Click")
		Return
	End If
	If tUndo.F_Col = 11 And tUndo.T_Col = 12 Then
		ColIni = 0
		ColEnd = lstColumns(12).Size - 1
		Dim tp As Int = imgNone.Top
		Dim lft As Int = imgNone.Left - (CPrm.WdtDest + dipX(5))
		Dim ct As Short = -1
		If ColEnd < ColIni Then Return
		For Count = ColEnd To ColIni Step -1
			ct = ct + 1
			TurnIdx = lstColumns(12).Get(Count)
			imgCards(TurnIdx).Bitmap = DrawImage(Cards(TurnIdx).Seq)
			imgCards(TurnIdx).BringToFront
			imgCards(TurnIdx).Left = lft + ct * 0.15
			imgCards(TurnIdx).Top = tp - ct * 0.15
			Cards(TurnIdx).Turned = True
			lstColumns(12).RemoveAt(Count)
			lstColumns(11).Add(TurnIdx)
			Cards(TurnIdx).Col = 11
		Next
		lstUndo.RemoveAt(szU)
		Return		
	End If
	If tUndo.F_Col = 12 Then
		Dim Last As Short = lstColumns(Col_Clicked).Size - 1
		If Last < 0  Then Return
		TurnIdx = lstColumns(Col_Clicked).Get(Last)
		imgCards(TurnIdx).BringToFront
		Cards(TurnIdx).Turned = False
		lstColumns(Col_Clicked).RemoveAt(Last)
		lstColumns(12).Add(TurnIdx)
		Cards(TurnIdx).Col = 12
		Dim Sz As Short = lstColumns(12).Size
		Dim lft As Int = imgNone.Left 
		Dim tp As Int = imgNone.top
		dSpeed(TurnIdx, lft + Sz * 0.15 , tp - Sz * 0.15)
		Dim Turn As clTurn
		Turn.Initialize(Me)
		Turn.Img_to_Turn(imgCards(TurnIdx), Cards(TurnIdx).Seq, True, "*")
		lstUndo.RemoveAt(szU)
		Return
	End If
	If Col_Clicked < 11 Then
		ColIni = Col_Clicked 
		ColEnd = tUndo.F_Col
		For i = tUndo.Qt To 1 Step -1
			Dim szIni As Short = lstColumns(ColIni).Size
			Count = lstColumns(ColIni).Get(szIni - i)
			imgCards(Count).BringToFront
			Dim Sz As Short = lstColumns(ColEnd).Size
			If ColEnd > 10 Then
				Dim lft As Int = imgNone.Left - (CPrm.WdtSrc + dipX(5))
				Dim tp As Int = imgNone.top
				dSpeed(Count, lft + Sz * 0.15 , tp - Sz * 0.15)
			else if ColEnd > 6 Then
				dSpeed(Count, imgA(ColEnd-7).Left, CardsTop)
			Else
				BlockTop = CardsTop1 + Sz * (CPrm.HgtDest * CardsStp)
				dSpeed(Count, imgK(ColEnd).Left, BlockTop)
			End If
			lstColumns(ColEnd).Add(Count)
			Cards(Count).Col = ColEnd
			lstColumns(ColIni).RemoveAt(szIni-i)
		Next
		lstUndo.RemoveAt(szU)
	End If
End Sub

Private Sub imgNone_Click
	If DateTime.Now - timeClick < 1000 Then
		Return
	End If
	timeClick =	DateTime.Now	
	If Not(isInitialized) Then Return
	If lstColumns(11).Size = 0 Then Return
	ColIni = 0
	ColEnd = lstColumns(11).Size - 1
	Dim tp As Int = imgNone.Top
	Dim lft As Int = imgNone.Left
	Dim ct As Short = -1
	If ColEnd < ColIni Then Return
	For Count = ColEnd To ColIni Step -1
		ct = ct + 1
		TurnIdx = lstColumns(11).Get(Count)
		imgCards(TurnIdx).Bitmap = DrawImage(55)
		imgCards(TurnIdx).BringToFront
		imgCards(TurnIdx).Left = lft + ct * 0.15
		imgCards(TurnIdx).Top = tp - ct * 0.15
		Cards(TurnIdx).Turned = False
		lstColumns(11).RemoveAt(Count)
		lstColumns(12).Add(TurnIdx)
		Cards(TurnIdx).Col = 12
	Next
	Col_Clicked = 12
	CallSubDelayed(Me, "Click12")
	Save_Undo(11, 12, ct + 1)
End Sub

Private Sub imgCards_Click
	If DateTime.Now - timeClick < 500 Then
		Return
	End If
	timeClick =	DateTime.Now
	If isInitialized = False Then Return
	Dim imgv As ImageView = Sender
	img_Num = imgv.tag
	Col_Clicked = Cards(img_Num).Col
	lstSelected.Clear
	Clk(Col_Clicked) = Clk(Col_Clicked)+1
	If Col_Clicked = 12  Then
		Click12
		Return
	Else If Col_Clicked = 11 Then
		Click11
		Return
	Else If Col_Clicked > 6  Then
		Click7to10
		Return
	Else
		Click0to6		
	End If
End Sub

Private Sub Click0to6
	Dim flg As Boolean
	Dim cLast, tLast As Short
	Dim cClicked As CardParms
	Dim cTarget As CardParms
	Dim cTest As CardParms
	cLast = lstColumns(Col_Clicked).Size -1
	If cLast > -1 Then
		cClicked = Cards(lstColumns(Col_Clicked).Get(cLast))
		flg = ck_7_to_10(cClicked)
		If flg Then Return
		Dim tmp As Short = cLast
		Do While flg = False
			cClicked = Cards(lstColumns(Col_Clicked).Get(tmp))
			For z = 0 To 6
				If z <> Col_Clicked Then
					tLast = lstColumns(Z).Size -1
					If tLast = -1 Then 
						If cClicked.Value = 13 Then
							ColIni = Col_Clicked
							ColEnd = z
							For l = tmp To cLast
								cClicked = Cards(lstColumns(Col_Clicked).Get(l))
								lstSelected.Add(cClicked.imgN)
							Next
							flg = True
							Move_Cards(ColEnd)
							Exit
						Else
							Continue
						End If
					End If
					cTarget = Cards(lstColumns(z).Get(tLast))
					If (cClicked.Naipe Mod 2) <> (cTarget.Naipe Mod 2) And cClicked.Value - cTarget.Value = - 1  Then
						ColIni = Col_Clicked
						ColEnd = z
						For l = tmp To cLast
							cClicked = Cards(lstColumns(Col_Clicked).Get(l))
							lstSelected.Add(cClicked.imgN)
						Next
						flg = True
						Move_Cards(ColEnd)
						Exit
					End If
				End If
			Next
			If flg = False And tmp > 0 Then
				tmp = tmp - 1
				cTest = Cards(lstColumns(Col_Clicked).Get(tmp))
				If (cClicked.Naipe Mod 2) = (cTest.Naipe Mod 2) _
					Or cClicked.Value - cTest.Value <> -1 _
					Or cTest.Turned = False Then
					Exit
				End If
			Else if flg = False Then
				Exit
			End If
		Loop
	End If	
	
End Sub

Private Sub Click12
	Dim Last As Short = lstColumns(Col_Clicked).Size - 1
	If Last < 0  Then Return
	TurnIdx = lstColumns(Col_Clicked).Get(Last)
	imgCards(TurnIdx).BringToFront
	Cards(TurnIdx).Turned = True
	lstColumns(Col_Clicked).RemoveAt(Last)
	lstColumns(11).Add(TurnIdx)
	Cards(TurnIdx).Col = 11
	Dim Sz As Short = lstColumns(11).Size
	Dim lft As Int = imgNone.Left - (CPrm.WdtDest + dipX(5))
	Dim tp As Int = imgNone.top
	dSpeed(TurnIdx, lft + Sz * 0.15 , tp - Sz * 0.15)
	Save_Undo(Col_Clicked, 11, 1)
	timeClick =	DateTime.Now
	Dim Turn As clTurn
	Turn.Initialize(Me)
	Turn.Img_to_Turn(imgCards(TurnIdx), Cards(TurnIdx).Seq, False, "CkOk")
'	lbMov.Text = lbMov.Text + 1
End Sub

Private Sub Click7to10
	Dim cLast As Short
	Dim cClicked As CardParms
	cLast = lstColumns(Col_Clicked).Size -1
	If cLast > -1 Then
		cClicked = Cards(lstColumns(Col_Clicked).Get(cLast))
		ck_0_to_6(cClicked)
	End If	
End Sub

Private Sub Click11
	Dim flg As Boolean
	Dim cLast As Short
	Dim cClicked As CardParms
	cLast = lstColumns(Col_Clicked).Size -1
	If cLast > -1 Then
		cClicked = Cards(lstColumns(Col_Clicked).Get(cLast))
		flg = ck_7_to_10(cClicked)
		If flg Then Return
		flg = ck_0_to_6(cClicked)
	End If
End Sub

Private Sub ck_7_to_10(ccl As CardParms) As Boolean
	Dim cTarget As CardParms
	Dim tlast As Short
	For z = 7 To 10
		tlast = lstColumns(Z).Size -1
		If tlast > - 1 Then
			cTarget = Cards(lstColumns(z).Get(tlast))
			If cTarget.Turned And _
				ccl.Naipe = cTarget.Naipe  And _
				ccl.Value - cTarget.Value = 1 Then
				ColIni = Col_Clicked
				ColEnd = z
				lstSelected.Add(ccl.imgN)
				Move_Cards(ColEnd)
				Return True
				Exit
			End If
		End If
	Next
	Return False
End Sub

Private Sub ck_0_to_6(ccl As CardParms) As Boolean
	Dim cTarget As CardParms
	Dim tlast As Short
	For z = 0 To 6
		tlast = lstColumns(Z).Size -1
		If tlast > - 1 And ccl.Value < 13 Then
			cTarget = Cards(lstColumns(z).Get(tlast))
			If (ccl.Naipe Mod 2) <> (cTarget.Naipe Mod 2) And ccl.Value - cTarget.Value = - 1  Then
				ColIni = Col_Clicked
				ColEnd = z
				lstSelected.Add(ccl.imgN)
				Move_Cards(ColEnd)
				Return True
			End If
		Else If tlast = -1 And ccl.Value = 13 And Col_Clicked = 11 Then
			ColIni = Col_Clicked
			ColEnd = z
			lstSelected.Add(ccl.imgN)
			Move_Cards(ColEnd)
			Return True
		End If
	Next
	Return False	
End Sub

Private Sub CkOk
	Dim flg As Boolean = True
	For i = 0 To 6	
		For z = 0 To lstColumns(i).Size -1
			Dim it As Short = lstColumns(i).Get(z)
			If Not(Cards(it).Turned) Then
				flg = False
				Exit
			End If
		Next
		If flg = False Then Exit
	Next
	ck_Complete
End Sub

Private Sub ck_Complete
		Dim flg As Boolean = False
		Dim cardMin As Short = 99
		Dim cLast, tLast As Short
		Dim cClicked As CardParms
		Dim cTarget As CardParms
		'take the lower value of the cards already ok
		For i = 7 To 10
			Dim tLast As Short = lstColumns(i).Size -1
			If tLast > - 1 Then
				cTarget = Cards(lstColumns(i).Get(tLast))
				cardMin = Min(cardMin, cTarget.Value)
			Else
				cardMin = 0
				Exit
			End If
		Next
		If cardMin = 13 Then
			DoEvents
			ck_End
			Return
		End If
		lstSelected.Clear
		For i = 0 To 6
			cLast = lstColumns(i).Size -1
			If cLast > -1 Then
				cClicked = Cards(lstColumns(i).Get(cLast))
				For z = 7 To 10
					tLast = lstColumns(Z).Size -1
					If tLast > - 1 Then
						cTarget = Cards(lstColumns(z).Get(tLast))
						If cTarget.Turned And _
							cClicked.Naipe = cTarget.Naipe  And _
							cClicked.Value - cTarget.Value = 1 And _
							cClicked.Value < = cardMin + 2 Then
							ColIni = i
							ColEnd = z
							lstSelected.Add(cClicked.imgN)
							Col_Clicked = ColIni
							Move_Cards(ColEnd)
							flg= True
							Exit
						End If
					Else
						If cClicked.Value = 1 Then 
							ColIni = i
							ColEnd = z
							lstSelected.Add(cClicked.imgN)
							Col_Clicked = ColIni
							Move_Cards(ColEnd)
							flg= True
							Exit
						End If
					End If
				Next
				If flg Then Exit
			End If
		Next	
		If flg = False Then
			cLast = lstColumns(11).Size -1
			If cLast > -1 Then
				cClicked = Cards(lstColumns(11).Get(cLast))
				For z = 7 To 10
					tLast = lstColumns(Z).Size -1
					If tLast > - 1 Then
						cTarget = Cards(lstColumns(z).Get(tLast))
						If cTarget.Turned And _
							cClicked.Naipe = cTarget.Naipe  And _
							cClicked.Value - cTarget.Value = 1 And _
							cClicked.Value < = cardMin + 2 Then
							ColIni = 11
							ColEnd = z
							lstSelected.Add(cClicked.imgN)
							Col_Clicked = ColIni
							Move_Cards(ColEnd)
							flg= True
							Exit
						End If
					Else
						If cClicked.Value = 1 Then 
							ColIni = 11
							ColEnd = z
							lstSelected.Add(cClicked.imgN)
							Col_Clicked = ColIni
							Move_Cards(ColEnd)
							flg= True
							Exit
						End If
					End If
				Next
			End If
		End If
End Sub

Private Sub ck_End
	isInitialized = False
	gv.Initialize("gv")
	'gv.SetBackgroundImage(LoadBitmap(File.DirAssets, "BkNight.png"))
	Activity.AddView(gv, 0, 0, 100%x, 100%y)
	If gv.IsHardwareAccelerated = False Then
		Msgbox("Hardware acceleration is not supported!!!", "")
	End If	
	FireIsActive = True
	btExit.BringToFront
	btNew.BringToFront
	Activity.Color = Colors.RGB(24, 24, 24)
	Fire.Initialize(gv, 8)
End Sub

Private Sub Move_Cards(to_col As Short)
	Dim SelSz As Short = lstSelected.Size
	For i = 0 To SelSz - 1
		Dim sz As Short = lstColumns(to_col).Size
		img_Num = lstSelected.Get(i)
		Cards(img_Num).Col = to_col
		imgCards(img_Num).BringToFront
		If to_col < 7 Then
			BlockTop = CardsTop1 + sz * (CPrm.HgtDest * CardsStp)
			dSpeed(img_Num, imgK(to_col).Left, BlockTop)
		else If to_col < 11 Then
			dSpeed(img_Num, imgA(to_col-7).Left, CardsTop)
		End If
		Dim itPos As Short = lstColumns(Col_Clicked).IndexOf(img_Num)
		lstColumns(Col_Clicked).RemoveAt(itPos)
		lstColumns(to_col).Add(img_Num)
	Next
	Save_Undo(Col_Clicked, to_col, SelSz)	
	If Col_Clicked < 7 Then 
		CallSubDelayed2(Me, "TurnCol", "CkOk")
	End If
	If Col_Clicked = 11 Then 
		CallSubDelayed(Me, "CkOk")
	End If
	timeClick =	DateTime.Now	

End Sub

'Maintain the same speed of the animations
Private Sub dSpeed(imgN As Short, to_lft As Double, to_top As Double) 'As Double
	Dim lft As Double = imgCards(imgN).left
	Dim top As Double = imgCards(imgN).Top
	Dim side_Width As Double = Abs(to_lft - lft)
	Dim side_Height As Double = Abs(to_top - top)
	Dim Spd As Double = Sqrt(Power(side_Height, 2) + Power(side_Width, 2)) '* 2
	imgCards(imgN).SetLayoutAnimated(Spd, to_lft, to_top, CPrm.WdtDest, CPrm.HgtDest)
End Sub


Private Sub TurnCol(sb As String)
	Dim Sz As Short = lstColumns(Col_Clicked).Size
	If Sz = 0 Then 
		If sb <> "*" Then CallSub(Me, sb)
		Return
	End If
	TurnIdx = lstColumns(Col_Clicked).Get(Sz - 1)
	If Cards(TurnIdx).Turned Then 
		If sb <> "*" Then CallSub(Me, sb)
		Return
	End If
	Cards(TurnIdx).Turned = True
	Save_Undo(Col_Clicked, -99, 1)
	Dim Turn As clTurn
	Turn.Initialize(Me)
	Turn.Img_to_Turn(imgCards(TurnIdx), Cards(TurnIdx).Seq, False, sb)
End Sub

Private Sub dipX(Vl As Float) As Float
	Return  (Vl * Main.DeviceScale * Main.ScaleX)
End Sub

Private Sub dipY(Vl As Float) As Float
	Return  (Vl * Main.DeviceScale * Main.ScaleY)
End Sub

Private Sub DrawImage(cValue As Short) As Bitmap
	Dim cv As Canvas
	Dim BM As Bitmap
	Dim sTmp As Short
	Dim rtSrc, rtDst As Rect
	BM.InitializeMutable(CPrm.WdtDest,CPrm.HgtDest)
	cv.Initialize2(BM)
	
	#If WithAntiAliasing
		Utils.SetAntiAlias(cv, Utils.FILTER_BITMAP_FLAG)
	#End If
	
	sTmp = cValue Mod 13
	If sTmp = 0 Then sTmp = 13
	Dim cl As Short = CPrm.WdtSrc * (sTmp-1)
	Dim rw As Short  = ((cValue-sTmp)/13) * CPrm.HgtSrc
	rtSrc.Initialize(cl, rw, cl + CPrm.WdtSrc, rw + CPrm.HgtSrc)
	rtDst.Initialize(0, 0, CPrm.WdtDest, CPrm.HgtDest)
	cv.DrawBitmap(Bmp, rtSrc, rtDst)	
	Return BM
End Sub

Private Sub Save_Undo(fCol As Short, tCol As Short, Qt As Short)
	Dim tUndo As Undo
	tUndo.F_Col = fCol
	tUndo.T_Col = tCol
	tUndo.Qt = Qt
	lstUndo.Add(tUndo)
End Sub

'trying to remove the app from memory
Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK Or  KeyCode = KeyCodes.KEYCODE_HOME And isInitialized Then
		Dim res As Int = Msgbox2("Are you sure you want to quit this game?", "", "Yes", "", "No", Null)
    	If res = DialogResponse.NEGATIVE Then Return True
	End If
	If FireIsActive Then
		FireIsActive = False
		Fire.Stop
	End If
	Return False
End Sub

Sub Activity_Resume

End Sub


Sub Activity_Pause (UserClosed As Boolean)

End Sub

#If Java
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;
import android.graphics.Bitmap;
public void alphatize(Canvas mCanvas, Bitmap mBitmap, int mAlpha){
  Paint paint =new Paint();
  paint.setAlpha(mAlpha);
  Rect mDstRect = new Rect(0,0,mBitmap.getWidth(),mBitmap.getHeight()); //We are assuming they are the same size
  mCanvas.drawBitmap(mBitmap, null, mDstRect, paint);
}
#End If


