﻿Type=Activity
Version=7.01
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub Globals
	Type PointApi(X As Float, Y As Float)
	Type CParms(WdtSrc As Int, HgtSrc As Int, WdtDest As Int, HgtDest As Int) 
	Private lbInstr As Label 
	Private btCol(3) As Button
	Private btNew As Button
	Private btExit As Button
	Private CardBmp(21) As ImageView
	Private CardValue(21) As Short
	Private CardValueT(21) As Short
	Private CPrm As CParms
	Private Bmp As Bitmap
	Private CountGm As Short
    Private PosX, PosY As Int
	Private ColPos As Short
	Private ivBack As ImageView
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("L1")
	Activity.Title = "Trick 1"
	Dim Wd As Float = dipX(240)
	Dim lft As Float = (100%x - Wd) /2
	Dim hg As Float = dipX(200)
	Dim tp As Int = (100%y - hg) / 2
	ivBack.Initialize("")
	ivBack.Gravity = Gravity.FILL
	ivBack.Bitmap = LoadBitmap(File.DirAssets, "bkg.png")
	Activity.AddView(ivBack, lft, tp, Wd, hg)	
	lbInstr.Initialize("")
	lbInstr.TextColor = Colors.Yellow
	lbInstr.TextSize = 14 * Main.FontScale
	Activity.AddView(lbInstr, dipX(10), dipY(50), dipX(300), dipY(35))
	For i = 0 To 2
		btCol(i).Initialize("btCol")
		btCol(i).Tag = i
		btCol(i).Text = "Column " & (i+1)
		btCol(i).TextSize = 12 * Main.FontScale
		Dim lft As Float = 20 + i * 100
		Activity.AddView(btCol(i), dipX(lft), dipY(85), dipX(80), dipY(35))
	Next
	btExit.Initialize("btExit")
	btExit.Text = "Exit"
	btExit.TextSize = 12 * Main.FontScale
	Activity.AddView(btExit, dipX(20), dipY(360), dipX(80), dipY(35))
	btNew.Initialize("btNew")
	btNew.Text = "New"
	btNew.TextSize = 12 * Main.FontScale
	Activity.AddView(btNew, dipX(120), dipY(360), dipX(80), dipY(35))
	CPrm.WdtSrc = 71
	CPrm.HgtSrc = 96
	CPrm.WdtDest = dipX(CPrm.WdtSrc / 1.5)
	CPrm.HgtDest = dipX(CPrm.HgtSrc / 1.5)
	Bmp.Initialize(File.DirAssets, "Cards01.png")
	For i = 0 To 20
		CardBmp(i).Initialize("")
		CardBmp(i).Gravity = Gravity.FILL
		Activity.AddView(CardBmp(i), 0, 0, CPrm.WdtDest, CPrm.HgtDest)
	Next
	CountGm = 0
	Initialize_Cards
End Sub

Private Sub Initialize_Cards
	lbInstr.Text = "Memorize a card and press the corresponding column button."
	Dim tt As Short = 52
	Dim TCard(tt) As Short
	For i = 0 To 51
		TCard(i) = i+1
	Next
	For i = 0 To 20
		Dim rn As Short = Rnd(0, tt)
		CardValue(i) = TCard(rn)
		Dim sTmp As Short
		tt = tt - 1
		sTmp = TCard(rn)
		TCard(rn) = TCard(tt)
		TCard(tt) = sTmp
		CardBmp(i).Bitmap = DrawImage(CardValue(i))
	Next
    PosY = btCol(2).Top + btCol(2).Height + dipY(10) + 8 * CPrm.HgtDest * 0.40
	PosX = btCol(2).Left + (btCol(2).Width - CPrm.WdtDest) / 2
	For i = 0 To 20 Step -1
        CardBmp(i).Left = PosX
		CardBmp(i).Top = PosY
	Next	
	For i = 0 To 2
		btCol(i).Enabled = False
	Next
	btExit.Enabled = True
	btNew.Enabled = False
	CallSubDelayed(Me, "Show_Cards")
End Sub

Private Sub Show_Cards
    PosY = btCol(0).Top + btCol(0).Height + dipY(10)
	For ct = 0 To 20
		ColPos = (ct) Mod 3
	    PosX = btCol(ColPos).Left + (btCol(ColPos).Width - CPrm.WdtDest) / 2
		dSpeed(ct, PosX, PosY)
	    If (ct + 1) Mod 3 = 0 Then
			PosY = PosY + CPrm.HgtDest * 0.40
		End If
	Next
	For i = 0 To 2
		btCol(i).Enabled = True
	Next
End Sub

Private Sub btCol_Click
	Utils.SoundPlay(1)
	
	Dim bt As Button = Sender
	Dim idx As Short = bt.Tag + 1
    Dim b As Short = -1
    For i = 0 To 20
        CardValueT(i) = CardValue(i)
    Next
    CountGm = CountGm + 1
	Select Case CountGm
		Case 1
			lbInstr.Text = "Where is the card?"
		Case 2
			lbInstr.Text = "Last time... Where is the card?"
		Case 3
 			lbInstr.Text = ""
	End Select
	Dim i1, i2, i3, e1, e2, e3 As Short 
    Select Case idx
        Case 1
			i1 = 1: e1 = 19
			i2 = 0: e2 = 18
			i3 = 2: e3 = 20 
        Case 2
			i1 = 0: e1 = 18
			i2 = 1: e2 = 19
			i3 = 2: e3 = 20 
        Case 3
			i1 = 1: e1 = 19
			i2 = 2: e2 = 20 
			i3 = 0: e3 = 18
    End Select
	For i = i1 To e1 Step 3
	   b = b + 1
	   CardValue(b) = CardValueT(i)
	Next
	For i = i2 To e2 Step 3
	    b = b + 1
	   CardValue(b) = CardValueT(i)
	Next
	For i = i3 To e3 Step 3
	    b = b + 1
	   CardValue(b) = CardValueT(i)
	Next
	
	For i = 0 To 20
		CardBmp(i).Bitmap = DrawImage(CardValue(i))
	Next
    If CountGm = 3 Then
		For i = 0 To 2
			btCol(i).Enabled = False
		Next
		btNew.Enabled = False
		btExit.Enabled = False
		CountGm = 0
    	Dim PosX, PosY As Int
	    PosY = btCol(1).Top + btCol(1).Height + dipY(30)
	    PosX = btCol(1).Left + (btCol(1).Width - CPrm.WdtDest) / 2
		For i = 0 To 20
			CardBmp(i).Bitmap = DrawImage(55)
			dSpeed(i, PosX, PosY)
		Next
		lbInstr.Text = "Your Card"
		Dim ef As cEffect
		ef.Initialize(Me, PosX, PosY, CardBmp)
		CardBmp(20).Bitmap = DrawImage(CardValue(10))
    Else
	    PosY = btCol(2).Top + btCol(2).Height + dipY(10) + 8 * CPrm.HgtDest * 0.40
		PosX = btCol(2).Left + (btCol(2).Width - CPrm.WdtDest) / 2
		For i = 0 To 2
			btCol(i).Enabled = False
		Next
		For i = 20 To 0 Step -1
	        CardBmp(i).Left = PosX
			CardBmp(i).Top = PosY
		Next	
	    PosY = btCol(0).Top + btCol(0).Height + dipY(10)
		CallSubDelayed(Me, "Show_Cards")
	End If
End Sub

Private Sub enableButtons
	btNew.Enabled = True
	btExit.Enabled = True
End Sub

Private Sub DrawImage(cValue As Short) As Bitmap
	Dim cv As Canvas
	Dim BM As Bitmap
	Dim sTmp As Short
	Dim rtSrc, rtDst As Rect
	BM.InitializeMutable(CPrm.WdtDest,CPrm.HgtDest)
	cv.Initialize2(BM)
	
	#If WithAntiAliasing
		Utils.SetAntiAlias(cv, Utils.FILTER_BITMAP_FLAG)
	#End If
	
	sTmp = cValue Mod 13
	If sTmp = 0 Then sTmp = 13
	Dim cl As Short = CPrm.WdtSrc * (sTmp-1)
	Dim rw As Short  = ((cValue-sTmp)/13) * CPrm.HgtSrc
	rtSrc.Initialize(cl, rw, cl + CPrm.WdtSrc, rw + CPrm.HgtSrc)
	rtDst.Initialize(0, 0, CPrm.WdtDest, CPrm.HgtDest)
	cv.DrawBitmap(Bmp, rtSrc, rtDst)	
	Return BM
End Sub

Private Sub dSpeed(imgN As Short, to_lft As Int, to_top As Int) 'As Double
	Dim lft As Int = CardBmp(imgN).left
	Dim top As Int = CardBmp(imgN).Top
	Dim side_Width As Int = Abs(to_lft - lft)
	Dim side_Height As Int = Abs(to_top - top)
	Dim Spd As Int = Sqrt(Power(side_Height, 2) + Power(side_Width, 2)) * 2
	CardBmp(imgN).SetLayoutAnimated(Spd, to_lft, to_top, CPrm.WdtDest, CPrm.HgtDest)
End Sub

Private Sub btNew_Click
	Utils.SoundPlay(1)
	Initialize_Cards
End Sub

Private Sub btExit_Click
	
	Utils.SoundPlay(1)
	Activity.Finish
End Sub

'trying to remove the app from memory
Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK Or  KeyCode = KeyCodes.KEYCODE_HOME Then
		Utils.SoundPlay(2)
		Dim res As Int = Msgbox2("Are you sure you want to quit this game?", "", "Yes", "", "No", Null)
    	If res = DialogResponse.NEGATIVE Then Return True
	End If
	Return False
End Sub

Sub Activity_Resume
End Sub

Sub Activity_Pause (UserClosed As Boolean)
End Sub

Private Sub dipX(Vl As Float) As Float
	Return  (Vl * Main.DeviceScale * Main.ScaleX)
End Sub

Private Sub dipY(Vl As Float) As Float
	Return  (Vl * Main.DeviceScale * Main.ScaleY)
End Sub
